/*------------------------------------------------------
ObstacleDetection.ch 

[Simple program to make Finch Robot change directions 
and beak LED when it detects walls in front of it.]

Written by Nathan Wong, IEL Lab, UC Davis
5/14/2014
-------------------------------------------------------*/

#if 0
Finch Robot Control  (finch.exe)

Notes:
- finch.exe was compiled for a 32-bit windows O/S
- make sure that the hidapi.dll is in the current working directory
- plug in the finch-usb cable before starting the program

#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Finch.h"

#ifdef _LINUX_
#include <pthread.h>
#else
#include <conio.h>
#include <windows.h>
#endif

int main(int argc, char* argv[])
{
    int left, right;

    // attempt to connect to the finch hardware
    // ...finch must be already plugged into a usb port
    if (Fin_Init() < 0)
       exit(1);
    
    printf("Hit any key to exit the program\n");
    
    // Loop to continously move Finch robot forward
    do{
                Fin_Motor(-1, 100, 100);
                Fin_LED(0,255,0);
                Fin_Obstacle(&left,&right);
                //If Finch detects something on the right infrared sensor, Finch will turn left
                if (left == 0 && right == 1){
                    Fin_LED(255,0,0);
                    printf("Obstacle detected on right. Obstacle -- Left:%d   Right:%d \n", left, right);
                    Fin_Move(10, -140, 140);
                }
                //If Finch detects something on the left infrared sensor, Finch will turn right
                else if (left == 1 && right == 0){
                    Fin_LED(255,0,0);
                    printf("Obstacle detected on left. Obstacle -- Left:%d   Right:%d \n", left, right);
                    Fin_Move(10, 140, -140);
                }
                //If Finch detects something directly in front, Finch will back up and turn around
                else if (left == 1 & right == 1){
                    Fin_LED(255,0,0);
                    printf("Obstacle detected straight in front. Obstacle -- Left:%d   Right:%d \n", left, right);
                    Fin_Move(10, -200, -200);
                    Fin_Move(15, -140, 140);
                }
                Sleep(500);
    } while (!kbhit());         //exit loop when the user hits a key
    
    // disconnect before exiting the program
    Fin_Exit();
    return(0);

}
